#include <stdio.h>
#include <stdlib.h>

// 定义学生信息的数据结构，链表的节点
typedef struct stu_s
{
    char sid;
    char name[32];
    int age;

    struct stu_s *next;
} STU;

void shows(STU *head)
{
    STU *pi = head;
    printf("学号\t姓名\t年龄\n");

    while (NULL != pi)
    {
        printf("%d\t%s\t%d\n", pi->sid, pi->name, pi->age);
        pi = pi->next;
    }
}

STU *insert_head(STU *head, STU *item)
{
    printf("2 %p\n", head);

    // 实现头部插入
    if (NULL == head) // 如果是第一个节点（空链表）
    {
        head = item;
    }
    else
    {
        item->next = head; // 新节点指向原来的头节点
        head = item;       // item 变成新的头节点
    }
    printf("3 %p\n", head);

    return head; // 返回头节点，头指针不能改变
}

STU *insert_end(STU *head, STU *item)
{
    // 实现尾部插入
    if (NULL == head) // 如果是第一个节点（空链表）
    {
        head = item;
    }
    else
    {
        STU *pi = head;
        while (NULL != pi->next)
        {
            pi = pi->next;
        }
        pi->next = item;
    }

    return head; // 返回头节点，头指针不能改变
}

int main()
{
    // 静态生成学生信息的链表
    STU s1 = {1, "张三", 18, NULL}; // 头节点: 参数说明: 学号, 姓名, 年龄, 下一个节点的地址
    STU s2 = {2, "李四", 19, NULL};
    STU s3 = {3, "王五", 20, NULL};

    STU *head = &s1; // 头节点
    s1.next = &s2;   // 头节点指向第二个节点
    s2.next = &s3;   // 第二个节点指向第三个节点
    s3.next = NULL;  // 第三个节点指向空

    STU s4 = {4, "赵六", 21};
    head = insert_head(head, &s4); // 头插法，地址会改变，需要返回头节点，主函数需要接收

    printf("1 %p\n", head);

    shows(head);

    // insert_end(head, &(STU){5, "孙七", 22, NULL});
    head = insert_head(head, &(STU){5, "孙七", 22, NULL}); // 临时变量，存在栈中，函数结束后会被释放，需要返回头节点，主函数需要接收

    printf("1 %p\n", head);

    shows(head);

    return 0;
}